import unittest
from unittest.mock import patch

from tmc import points
from tmc.utils import load_module, reload_module, get_stdout, sanitize
from functools import reduce
from random import randint

exercise = 'src.multiplication'

def format_tuple(d : tuple):
    return str(d).replace("'","")

@points('1.multiplication')
class MultiplicationTest(unittest.TestCase):
    @classmethod
    def setUpClass(cls):
        with patch('builtins.input', side_effect =['2']):
            cls.module = load_module(exercise, 'en')

    def test_multiplication(self):
        values = [2, 3, 4]
        for test_case in values:
            with patch('builtins.input', side_effect = [test_case]):
                reload_module(self.module)
                output = get_stdout()
                output_list = output.split("\n")
                cor = []    
                for i in range(1, int(test_case) + 1):
                    for j in range(1, int(test_case) + 1):
                        cor.append(f"{i} x {j} = {i*j}")
                self.assertEqual(len(output_list), len(cor), f"Ditt program bör skriva ut {len(cor)} rader, nu skriver det ut {len(output_list)} rader, när input är {test_case}.")
                r = 1
                cccc = "\n".join(cor)
                for l1,l2 in zip(cor, output_list):
                    self.assertTrue(sanitize(l1) == sanitize(l2), 
                        f"Utskriften i raden {r} är felaktig: ditt program bör skrivas ut\n{cccc}\nmen det skrivs ut\n{output}\nnär input är {test_case}")
                    r += 1

if __name__ == '__main__':
    unittest.main()